
import java.awt.Color;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.Polygon;
import java.awt.event.MouseEvent;
import java.util.Random;
import javax.swing.JPanel;
import java.awt.event.MouseMotionAdapter;

/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */
/**
 *
 * @author petr
 */
public class Hvezda extends JPanel {

    /**
     * Pocet cipu hvezdy
     */
    private int pocetCipu;
    /**
     * Barva hvezdy
     */
    private Color color;
    /**
     * Posun uhlu rotace hvezdy
     */
    private double posun;

    public Hvezda(int pocetCipu) {
        this.pocetCipu = pocetCipu > 3 ? pocetCipu : 3;
        Random gen = new Random();
        this.color = new Color(gen.nextInt(255), gen.nextInt(255), gen.nextInt(255));
        this.addMouseMotionListener(
                new MouseMotionAdapter() {

                    @Override
                    public void mouseMoved(MouseEvent e) {
                        Hvezda.this.posun += 2 * Math.PI / 180f;
                        repaint();
                    }

                    @Override
                    public void mouseDragged(MouseEvent e) {
                        Hvezda.this.posun -= 2 * Math.PI / 180f;
                        repaint();
                    }
                });
    }

    @Override
    public void paintComponent(Graphics g) {
        super.paintComponent(g);
        Graphics2D g2d = (Graphics2D) g;

        g2d.setPaint(Color.WHITE);
        g2d.fillRect(0, 0, this.getWidth(), this.getHeight());

        int r1 = this.getWidth() > this.getHeight() ? this.getHeight() : this.getWidth();
        r1 = r1 / 2;
        int r2 = r1 / 2;
        final double uhel1 = 360f / this.pocetCipu * Math.PI / 180f; // uhel v radianech
        long x, y;
        double u;
        Polygon vypln = new Polygon();

        for (int i = 0; i < this.pocetCipu; i++) {
            u = (uhel1 * i) + posun;
            y = Math.round(Math.sin(u) * r1 + this.getHeight() / 2f);
            x = Math.round(Math.cos(u) * r1 + this.getWidth() / 2f);
            vypln.addPoint((int) x, (int) y);


            u = (uhel1 * i) + uhel1 / 2f + posun; // uhel v radianech
            y = Math.round(Math.sin(u) * r2 + this.getHeight() / 2f);
            x = Math.round(Math.cos(u) * r2 + this.getWidth() / 2f);
            vypln.addPoint((int) x, (int) y);
        }

        g2d.setPaint(this.color);
        g2d.fillPolygon(vypln);
        g2d.setPaint(Color.BLACK);
        g2d.drawPolygon(vypln);
    }
}
